hdu 1348 Wall (凸包)

Wall


Time Limit: 2000/1000 MS
(Java/Others)    Memory Limit: 65536/32768 K
(Java/Others)
Total Submission(s): 3139    Accepted
Submission(s): 888

Problem Description

Once upon a time there was a greedy King who ordered
his chief Architect to build a wall around the King‘s castle. The King was so
greedy, that he would not listen to his Architect‘s proposals to build a
beautiful brick wall with a perfect shape and nice tall towers. Instead, he
ordered to build the wall around the whole castle using the least amount of
stone and labor, but demanded that the wall should not come closer to the castle
than a certain distance. If the King finds that the Architect has used more
resources to build the wall than it was absolutely necessary to satisfy those
requirements, then the Architect will loose his head. Moreover, he demanded
Architect to introduce at once a plan of the wall listing the exact amount of
resources that are needed to build the wall.
Your task is to help poor
Architect to save his head, by writing a program that will find the minimum
possible length of the wall that he could build around the castle to satisfy
King‘s requirements.



The task is
somewhat simplified by the fact, that the King‘s castle has a polygonal shape
and is situated on a flat ground. The Architect has already established a
Cartesian coordinate system and has precisely measured the coordinates of all
castle‘s vertices in feet.

Input

The first line of the input file contains two integer
numbers N and L separated by a space. N (3 <= N <= 1000) is the number of
vertices in the King‘s castle, and L (1 <= L <= 1000) is the minimal
number of feet that King allows for the wall to come close to the
castle.

Next N lines describe coordinates of castle‘s vertices in a
clockwise order. Each line contains two integer numbers Xi and Yi separated by a
space (-10000 <= Xi, Yi <= 10000) that represent the coordinates of ith
vertex. All vertices are different and the sides of the castle do not intersect
anywhere except for vertices.

Output

Write to the output file the single number that
represents the minimal possible length of the wall in feet that could be built
around the castle to satisfy King‘s requirements. You must present the integer
number of feet to the King, because the floating numbers are not invented yet.
However, you must round the result in such a way, that it is accurate to 8
inches (1 foot is equal to 12 inches), since the King will not tolerate larger
error in the estimates.

This problem contains multiple test
cases!

The first line of a multiple input is an integer N, then a blank
line followed by N input blocks. Each input block is in the format indicated in
the problem description. There is a blank line between input blocks.

The
output format consists of N output blocks. There is a blank line between output
blocks.

Sample Input

1

9 100

200 400

300 400

300 300

400 300

400 400

500 400

500 200

350 200

200 200

Sample Output

1628

Source

Northeastern
Europe 2001

Recommend

JGShining   |   We have
carefully selected several similar problems for you:  2150 1147 1558 1374 1756

题目给出一个城堡的所有角的坐标,求离城堡距离不小于L的城墙的最小长度。

简单凸包,题意和我的想法有点出入,既然是要求最小的长度,就不是简单的凸包可以解决的,额,忽略细节的话就是凸包模板题。

求凸包的长度+半径为L的圆的周长。


 1 //31MS     256K    1479B     G++
2 #include<stdio.h>
3 #include<stdlib.h>
4 #include<math.h>
5 #define N 1005
6 #define pi 3.1415926
7 struct node{
8 double x,y;
9 }p[N],stack[N];
10 double dist(node a,node b)
11 {
12 return sqrt((a.y-b.y)*(a.y-b.y)+(a.x-b.x)*(a.x-b.x));
13 }
14 double crossprod(node a,node b,node c)
15 {
16 return ((b.x-a.x)*(c.y-a.y)-(c.x-a.x)*(b.y-a.y))/2;
17 }
18 int cmp(const void*a,const void*b)
19 {
20 node c=*(node*)a;
21 node d=*(node*)b;
22 double k=crossprod(p[0],c,d);
23 if(k<0 || !k && dist(p[0],c)>dist(p[0],d))
24 return 1;
25 return -1;
26 }
27 double graham(int n)
28 {
29 for(int i=1;i<n;i++)
30 if(p[i].x<p[0].x || p[i].x==p[0].x && p[i].y<p[0].y){
31 node temp=p[0];
32 p[0]=p[i];
33 p[i]=temp;
34 }
35 qsort(p+1,n-1,sizeof(p[0]),cmp);
36 p[n]=p[0];
37 for(int i=0;i<3;i++) stack[i]=p[i];
38 int top=2;
39 for(int i=3;i<n;i++){
40 while(crossprod(stack[top-1],stack[top],p[i])<=0 && top>=2)
41 top--;
42 stack[++top]=p[i];
43 }
44 double ans=dist(stack[0],stack[top]);
45 for(int i=0;i<top;i++)
46 ans+=dist(stack[i],stack[i+1]);
47 return ans;
48 }
49 int main(void)
50 {
51 int t,n;
52 double l;
53 scanf("%d",&t);
54 while(t--)
55 {
56 scanf("%d%lf",&n,&l);
57 for(int i=0;i<n;i++)
58 scanf("%lf%lf",&p[i].x,&p[i].y);
59 double ans=2*l*pi;
60 ans+=graham(n);
61 printf("%.0lf\n",ans);
62 if(t) printf("\n");
63 }
64 return 0;
65 }

时间: 2024-12-31 03:46:33

hdu 1348 Wall (凸包)的相关文章

hdu 1348 Wall (凸包模板)

/* 题意: 求得n个点的凸包,然后求与凸包相距l的外圈的周长. 答案为n点的凸包周长加上半径为L的圆的周长 */ # include <stdio.h> # include <math.h> # include <string.h> # include <algorithm> using namespace std; # define PI acos(-1.0) struct node { int x; int y; }; node a[1010],res

POJ 1113 || HDU 1348: wall(凸包问题)

传送门: POJ:点击打开链接 HDU:点击打开链接 下面是POJ上的题: Wall Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 29121   Accepted: 9746 Description Once upon a time there was a greedy King who ordered his chief Architect to build a wall around the King's cast

hdu 1348 (凸包求周长)

链接:http://acm.hdu.edu.cn/showproblem.php?pid=1348 Wall Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 3229    Accepted Submission(s): 919 Problem Description Once upon a time there was a greedy

hdu 1348 Wall(凸包模板题)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1348 Wall Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 3386    Accepted Submission(s): 968 Problem Description Once upon a time there was a gre

HDU 1348 Wall 【凸包】

<题目链接> 题目大意: 给出二维坐标轴上 n 个点,这 n 个点构成了一个城堡,国王想建一堵墙,城墙与城堡之间的距离总不小于一个数 L ,求城墙的最小长度,答案四舍五入. 解题分析: 求出这些点所围成的凸包,然后所围城墙的长度就为 该凸包周长 + 以该距离为半径的圆的周长.具体证明如下: 下面的模板还没有整理好 Graham 凸包算法 #include<iostream> #include<cstdio> #include<cmath> #include&

HDOJ 1348 Wall 凸包

Wall Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 4001    Accepted Submission(s): 1131 Problem Description Once upon a time there was a greedy King who ordered his chief Architect to build a

HDU 5928 DP 凸包graham

给出点集,和不大于L长的绳子,问能包裹住的最多点数. 考虑每个点都作为左下角的起点跑一遍极角序求凸包,求的过程中用DP记录当前以j为当前末端为结束的的最小长度,其中一维作为背包的是凸包内侧点的数量.也就是 dp[j][k]代表当前链末端为j,其内部点包括边界数量为k的最小长度.这样最后得到的一定是最优的凸包. 然后就是要注意要dp[j][k]的值不能超过L,每跑一次凸包,求个最大的点数量就好了. 和DP结合的计算几何题,主要考虑DP怎么搞 /** @Date : 2017-09-27 17:27

POJ 3528 hdu 3662 三维凸包模板题

POJ 3528题:http://poj.org/problem?id=3528 HDU 3662:http://acm.hdu.edu.cn/showproblem.php?pid=3662 一个是求三维凸包面数,一个是求三维凸包表面积,都是很裸的. 贴代码: #include<stdio.h> #include<algorithm> #include<string.h> #include<math.h> #include<stdlib.h>

hdu 1348(凸包)

Wall Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4903    Accepted Submission(s): 1419 Problem Description Once upon a time there was a greedy King who ordered his chief Architect to build a